/*
 * pi3's Linux kernel Runtime Guard
 *
 * Component:
 *  - Intercept lookup_user_key function
 *
 * Notes:
 *  - Exploit Detection features needs to whitelist process which
 *    legitimately increases or changes their privileges structure.
 *
 * Caveats:
 *  - Keyring support
 *
 * Timeline:
 *  - Created: 12.XII.2017
 *
 * Author:
 *  - Adam 'pi3' Zabrocki (http://pi3.com.pl)
 *
 */

#ifndef P_LKRG_EXPLOIT_DETECTION_LOOKUP_USER_KEY_H
#define P_LKRG_EXPLOIT_DETECTION_LOOKUP_USER_KEY_H

/* per-instance private data */
struct p_lookup_user_key_data {
    ktime_t entry_stamp;
};


int p_lookup_user_key_ret(struct kretprobe_instance *ri, struct pt_regs *p_regs);
int p_lookup_user_key_entry(struct kretprobe_instance *p_ri, struct pt_regs *p_regs);
int p_install_lookup_user_key_hook(void);
void p_uninstall_lookup_user_key_hook(void);

#endif
